Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Azure/DAL.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Azure/DAL.cs	(revision 9323)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Azure/DAL.cs	(revision 9324)
@@ -162,4 +162,26 @@
     }
 
+    public bool Delete(string username, string experimentId) {
+      TableServiceContext serviceContext = TableClient.GetDataServiceContext();
+      TableClient.CreateTableIfNotExist(AzureConstants.EXPERIMENT_TABLE);
+      var entity = (from e in serviceContext.CreateQuery<ExperimentEntity>(AzureConstants.EXPERIMENT_TABLE)
+                    where e.ExperimentId == experimentId
+                    select e).FirstOrDefault();
+
+      if (entity == null)
+        return false;
+
+      if (entity.ExperimentJsonUrl != null) {
+        CloudBlobContainer container = BlobClient.GetContainerReference(AzureConstants.EXPERIMENT_BLOB_CONTAINER);
+        container.CreateIfNotExist();
+        var blob = container.GetBlobReference(entity.ExperimentJsonUrl);
+        blob.DeleteIfExists();
+      }
+
+      serviceContext.DeleteObject(entity);
+      serviceContext.SaveChangesWithRetries();
+      return true;
+    }
+
     public bool DeleteByName(string username, string experiment) {
       TableServiceContext serviceContext = TableClient.GetDataServiceContext();
@@ -209,5 +231,5 @@
     //}
 
-    public IEnumerable<Model.Experiment> GetExperiments(string user) {
+    public IEnumerable<Model.Experiment> GetExperiments(string user, bool namesOnly=false) {
       TableServiceContext serviceContext = TableClient.GetDataServiceContext();
       TableClient.CreateTableIfNotExist(AzureConstants.EXPERIMENT_TABLE);
@@ -216,11 +238,16 @@
                     select e).ToList();
       var experiments = new List<Experiment>();
-      CloudBlobContainer container = BlobClient.GetContainerReference(AzureConstants.EXPERIMENT_BLOB_CONTAINER);
-      container.CreateIfNotExist();
-      foreach (var entity in entites) {
-        var blob = container.GetBlobReference(entity.ExperimentJsonUrl);
-        experiments.Add(AlgorithmConverter.ConvertJsonToExperiment(blob.DownloadText()));
-      }
-      return experiments;
+      if (namesOnly) {
+        return (from e in entites select new Model.Experiment() { Id = e.ExperimentId, Name = e.RowKey.Split('_')[1] });
+      }
+      else {
+        CloudBlobContainer container = BlobClient.GetContainerReference(AzureConstants.EXPERIMENT_BLOB_CONTAINER);
+        container.CreateIfNotExist();
+        foreach (var entity in entites) {
+          var blob = container.GetBlobReference(entity.ExperimentJsonUrl);
+          experiments.Add(AlgorithmConverter.ConvertJsonToExperiment(blob.DownloadText()));
+        }
+        return experiments;
+      }
     }
 
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/HiveScenarioManager.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/HiveScenarioManager.cs	(revision 9323)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/HiveScenarioManager.cs	(revision 9324)
@@ -336,5 +336,5 @@
       else if (item is DoubleMatrix) {
         var matrix = item as DoubleMatrix;
-        double[][] matrixValue = new double[matrix.Rows][];
+        /*double[][] matrixValue = new double[matrix.Rows][];
         for (int i = 0; i < matrixValue.Length; ++i) {
           matrixValue[i] = new double[matrix.Columns];
@@ -342,6 +342,13 @@
             matrixValue[i][j] = matrix[i, j];
           }
-        }
-        result.Value = new HeuristicLab.Services.Optimization.ControllerService.Model.DecimalMatrix() { Name = name, Value = matrixValue };
+        } */
+        double[][] matrixValue = new double[matrix.Columns][];
+        for (int i = 0; i < matrix.Columns; ++i) {
+          matrixValue[i] = new double[matrix.Rows];
+          for (int j = 0; j < matrix.Rows; ++j) {
+            matrixValue[i][j] = matrix[j, i];
+          }
+        }        
+        result.Value = new HeuristicLab.Services.Optimization.ControllerService.Model.DecimalMatrix() { Name = name, Value = matrixValue, RowNames = (matrix.ColumnNames.Count() > 0 ? matrix.ColumnNames.ToArray() : null) };
       }
       else if (item is IStringConvertibleArray) {
@@ -369,9 +376,10 @@
           var columns = table.Rows.ToList()[i];
           names[i] = columns.Name;
-          results[i] = new double[columns.Values.Count];
+          results[i] = new double[columns.Values.Count];          
           for (int j=0; j < columns.Values.Count; j++) {
             results[i][j] = columns.Values[j];
           }
         }
+        results = transpose(results);
         result.Value = new HeuristicLab.Services.Optimization.ControllerService.Model.DecimalMatrix() { Name = name, Value = results, RowNames = names };
       }
@@ -437,4 +445,20 @@
     }
 
+    private double[][] transpose(double[][] arr) {
+      var width = arr.Length;
+      var height = arr[0].Length;
+
+      var res = new double[height][];
+      for (var i = 0; i < height; i++) 
+        res[i] = new double[width];
+
+      for (var i = 0; i < width; i++) {
+        for (var j = 0; j < height; j++) {
+          res[j][i] = arr[i][j];
+        }
+      }
+      return res;
+    }
+
     private string GetMapperFromBlobStore(string scenarioName) {
       var scenarioDao = dal.ScenarioDao;
@@ -482,5 +506,5 @@
 
     public bool DeleteExperiment(User user, string experiment) {
-      return dal.ExperimentDao.DeleteByName(user.Username, experiment);
+      return dal.ExperimentDao.Delete(user.Username, experiment);
     }
 
@@ -564,6 +588,6 @@
     }
 
-    public IEnumerable<Model.Experiment> GetExperiments(User user) {
-      return dal.ExperimentDao.GetExperiments(user.Username);
+    public IEnumerable<Model.Experiment> GetExperiments(User user, bool namesOnly=false) {
+      return dal.ExperimentDao.GetExperiments(user.Username, namesOnly);
     }
 
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/DAL.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/DAL.cs	(revision 9323)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/DAL.cs	(revision 9324)
@@ -22,6 +22,7 @@
     bool Update(string username, Experiment experiment);
     bool DeleteByName(string username, string experiment);
+    bool Delete(string username, string experimentId);
     Experiment FindByName(string username, string experiment);
-    IEnumerable<Experiment> GetExperiments(string user);
+    IEnumerable<Experiment> GetExperiments(string user, bool namesOnly = false);
     Experiment GetExperimentByName(string username, string scenario);
 
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IControllerService.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IControllerService.cs	(revision 9323)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IControllerService.cs	(revision 9324)
@@ -50,5 +50,5 @@
 
     [OperationContract]
-    IEnumerable<Experiment> GetExperiments(User user);
+    IEnumerable<Experiment> GetExperiments(User user, bool namesOnly = false);
 
     [OperationContract]
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IScenarioManager.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IScenarioManager.cs	(revision 9323)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IScenarioManager.cs	(revision 9324)
@@ -17,5 +17,5 @@
     string SaveExperiment(User user, Experiment experiment);
     IEnumerable<string> GetExperimentNames(User user);
-    IEnumerable<Model.Experiment> GetExperiments(User user);
+    IEnumerable<Model.Experiment> GetExperiments(User user, bool namesOnly = false);
     Experiment GetExperimentByName(User user, string scenario);
     Experiment GetExperimentById(User user, string nodeId);
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Mockup/MockupScenarioManager.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Mockup/MockupScenarioManager.cs	(revision 9323)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Mockup/MockupScenarioManager.cs	(revision 9324)
@@ -279,5 +279,5 @@
     }
 
-    public IEnumerable<Model.Experiment> GetExperiments(User user) {
+    public IEnumerable<Model.Experiment> GetExperiments(User user, bool namesOnly = false) {
       throw new NotImplementedException();
     }
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Parsers/AlgorithmConverter.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Parsers/AlgorithmConverter.cs	(revision 9323)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Parsers/AlgorithmConverter.cs	(revision 9324)
@@ -184,4 +184,19 @@
     }
 
+    public static JObject ConvertRunToJson(Run run) {
+      var jrun = new JObject();
+      jrun["id"] = run.Id;
+      jrun["name"] = run.Name;
+      jrun["results"] = ConvertParametersToJson(run.Results);
+      return jrun;
+    }
+
+    public static JArray ConvertRunsToJson(IList<Run> runs) {
+       var jarray = new JArray();
+      foreach (var run in runs)
+        jarray.Add(ConvertRunToJson(run));
+      return jarray;
+    }
+
     public static Experiment ConvertJsonToExperiment(string json) {
       var experiment = new Experiment();
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/PlaceholderControllerService.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/PlaceholderControllerService.cs	(revision 9323)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/PlaceholderControllerService.cs	(revision 9324)
@@ -185,6 +185,6 @@
 
 
-    public IEnumerable<Experiment> GetExperiments(User user) {
-      return hiveManager.GetExperiments(user);
+    public IEnumerable<Experiment> GetExperiments(User user, bool namesOnly=false) {
+      return hiveManager.GetExperiments(user, namesOnly);
     }
 
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/Datatypemapping.js
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/Datatypemapping.js	(revision 9323)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/Datatypemapping.js	(revision 9324)
@@ -1,159 +1,169 @@
-function DatatypeMapper() {
-}
+var OAAS_VIEW = (function (my, _, $, Backbone) {
+    my.DatatypeMapper = function () {
+        this.cb = {};
+        _.extend(this.cb, Backbone.Events);
 
-DatatypeMapper.prototype.mapHtml = function (property) {
-    var parameter = property.Value;
-    var key = property.Name;
-    if (property.Options) {
-        return DatatypeMapper_mapStrings(property.Name, property.Options, property.Value);
-    }
-    else if (parameter instanceof Array) {
-        // parameter is a vector of strings
-        if (parameter[0] instanceof String || typeof (parameter[0]) == 'string') {
-            return DatatypeMapper_mapStrings(key, parameter);
+        this.mapHtml = function (property, el) {
+            var parameter = property.Value;
+            var key = property.Name;
+            if (property.Options) {
+                var osv = new OAAS_VIEW.SelectionView({ model: property, el: el });
+                this.cb.listenTo(osv, 'selected', function (model) {
+                    property.Value = model.value;
+                });
+                osv.render();
+                return osv;
+            }
+            else if (parameter instanceof Array) {
+                // parameter is a matrix or vector of numbers
+                var tev = new OAAS_VIEW.TableEditView({ model: parameter, el: el, editable: true });
+                tev.render();
+                return tev;
+            }
+            else if (typeof (parameter) == 'boolean') {
+                var osv = new OAAS_VIEW.OptionSelectionView({ model: parameter, el: el, hideText: true });
+                this.cb.listenTo(osv, 'changed', function (model) {
+                    property.Value = model.checked;
+                });
+                osv.render();
+                return osv;
+            }
+            // parameter is a number
+            else if (!isNaN(parameter)) {
+                var nev = new OAAS_VIEW.NumberEditableView({ model: property, el: el });
+                nev.render();
+                return nev;
+            }
+            return 'No mapping for ' + typeof (parameter) + ' (Key: ' + key + ')';
+        };
 
-        }
-        // parameter is a vector of numbers
-        else if (!isNaN(parameter[0])) {
-            return DatatypeMapper_mapNumbers(key, parameter);
-        }
-        // parameter is a matrix of numbers
-        else {
-            return DatatypeMapper_mapMatrix(key, parameter);
-        }
 
     }
-    else if (typeof (parameter) == 'boolean') {
-        return DatatypeMapper_mapBoolean(key, parameter);
-    }
-    // parameter is a number
-    else if (!isNaN(parameter)) {
-        return DatatypeMapper_mapNumber(key, parameter);
-    }
-    return 'No mapping for ' + typeof (parameter) + ' (Key: ' + key + ')';
-}
 
 
-function DatatypeMapper_mapStrings(key, param, selected) {
-  // http://stackoverflow.com/questions/4814512/how-to-create-dropdown-list-dynamically-using-jquery
-  var s = $('<select name="' + key + '"/>');
-  for (var i = 0; i < param.length; i++) {
-    $('<option />', { value: param[i], text: param[i] }).appendTo(s);
-  }
-  s.val(selected);
-  return s;
-}
+    function DatatypeMapper_mapStrings(key, param, selected) {
+        // http://stackoverflow.com/questions/4814512/how-to-create-dropdown-list-dynamically-using-jquery
+        var s = $('<select name="' + key + '"/>');
+        for (var i = 0; i < param.length; i++) {
+            $('<option />', { value: param[i], text: param[i] }).appendTo(s);
+        }
+        s.val(selected);
+        return s;
+    }
 
-function DatatypeMapper_mapNumber(key, param) {
-  return $('<input type="text" name="' + key + '" />').val(param);
-}
+    function DatatypeMapper_mapNumber(key, param) {
+        return $('<input type="text" name="' + key + '" />').val(param);
+    }
 
-function DatatypeMapper_mapBoolean(key, param) {
-  var s = $('<select name="' + key + '"/>');
-  $('<option />', { value: 'true', text: 'true' }).appendTo(s);
-  $('<option />', { value: 'false', text: 'false' }).appendTo(s);
-  return s;
-}
+    function DatatypeMapper_mapBoolean(key, param) {
+        var s = $('<select name="' + key + '"/>');
+        $('<option />', { value: 'true', text: 'true' }).appendTo(s);
+        $('<option />', { value: 'false', text: 'false' }).appendTo(s);
+        return s;
+    }
 
-function DatatypeMapper_mapNumbers(key, param) {
-  // http: //stackoverflow.com/questions/8749236/create-table-with-jquery-append
-  var table = $('<table></table>').addClass('editableTable');
-  var head = $('<thead></thead>');
-  // create head elements
-  var headerRow = $('<tr></tr>');
-  $('<td />').text(key + ' Column').appendTo(headerRow);  
-  headerRow.appendTo(head);
-  head.appendTo(table);
-  var body = $('<tbody></tbody>');
-  for (var i = 0; i < param.length; i++) {
-    var row = $('<tr></tr>');
-    var td = $('<td />').appendTo(row);
-    $('<input type="text" name="' + key + '_' + i + '" />').val(param[i]).appendTo(td);    
-    row.appendTo(body);
-  }
-  body.appendTo(table);
-  return table;
-}
+    function DatatypeMapper_mapNumbers(key, param) {
+        // http: //stackoverflow.com/questions/8749236/create-table-with-jquery-append
+        var table = $('<table></table>').addClass('editableTable');
+        var head = $('<thead></thead>');
+        // create head elements
+        var headerRow = $('<tr></tr>');
+        $('<td />').text(key + ' Column').appendTo(headerRow);
+        headerRow.appendTo(head);
+        head.appendTo(table);
+        var body = $('<tbody></tbody>');
+        for (var i = 0; i < param.length; i++) {
+            var row = $('<tr></tr>');
+            var td = $('<td />').appendTo(row);
+            $('<input type="text" name="' + key + '_' + i + '" />').val(param[i]).appendTo(td);
+            row.appendTo(body);
+        }
+        body.appendTo(table);
+        return table;
+    }
 
-function DatatypeMapper_mapMatrix(key, param) {
-  // http: //stackoverflow.com/questions/8749236/create-table-with-jquery-append
-  var table = $('<table></table>').addClass('editableTable');
-  var head = $('<thead></thead>');
-  // create head elements
-  var headerRow = $('<tr></tr>');
-  for (var i = 0; i < param[0].length; i++) {
-    $('<td />').text(key + ' Column ' + i).appendTo(headerRow);
-  }
-  headerRow.appendTo(head);
-  head.appendTo(table);
-  var body = $('<tbody></tbody>');
-  for (var i = 0; i < param.length; i++) {
-    var row = $('<tr></tr>');
-    for (var j = 0; j < param[i].length; j++) {
-      var td = $('<td />').appendTo(row);      
-      $('<input type="text" name="' + key + '_' + i + '_' + j + '" />').val(param[i][j]).appendTo(td);      
+    function DatatypeMapper_mapMatrix(key, param) {
+        // http: //stackoverflow.com/questions/8749236/create-table-with-jquery-append
+        var table = $('<table></table>').addClass('editableTable');
+        var head = $('<thead></thead>');
+        // create head elements
+        var headerRow = $('<tr></tr>');
+        for (var i = 0; i < param[0].length; i++) {
+            $('<td />').text(key + ' Column ' + i).appendTo(headerRow);
+        }
+        headerRow.appendTo(head);
+        head.appendTo(table);
+        var body = $('<tbody></tbody>');
+        for (var i = 0; i < param.length; i++) {
+            var row = $('<tr></tr>');
+            for (var j = 0; j < param[i].length; j++) {
+                var td = $('<td />').appendTo(row);
+                $('<input type="text" name="' + key + '_' + i + '_' + j + '" />').val(param[i][j]).appendTo(td);
+            }
+            row.appendTo(body);
+        }
+        body.appendTo(table);
+        return table;
+
+        /*var table = '<table class="editableTable"><thead><tr>';
+        for (var i = 0; i < param[0].length; i++) {
+        table += '<th>' + key + ' Column ' + (i + 1) + '</th>';
+        }
+        table += '</tr>';
+        // foreach value entry (2d entry)
+        for (var i = 0; i < param.length; i++) {
+        table += '<tr>';
+        for (var j = 0; j < param[i].length; j++) {
+        table += '<td><input type="text" name="' + key + '_' + i + '_' + j + '" /></td>';
+        }
+        table += '</tr>';
+        }
+        return $*/
     }
-    row.appendTo(body);
-  }
-  body.appendTo(table);
-  return table;
 
-  /*var table = '<table class="editableTable"><thead><tr>';
-  for (var i = 0; i < param[0].length; i++) {
-    table += '<th>' + key + ' Column ' + (i + 1) + '</th>';
-  }
-  table += '</tr>';
-  // foreach value entry (2d entry)
-  for (var i = 0; i < param.length; i++) {
-    table += '<tr>';
-    for (var j = 0; j < param[i].length; j++) {
-      table += '<td><input type="text" name="' + key + '_' + i + '_' + j + '" /></td>';
+    /*
+    DatatypeMapper.prototype.mapString = function (value) {
+    if (value == "true") return true;
+    else if (value == "false") return false;
+    else if (!isNaN(value)) return parseFloat(value.replace(',', '.'));
+    return value;
     }
-    table += '</tr>';
-  }
-  return $*/
-}
 
-DatatypeMapper.prototype.mapString = function (value) {
-  if (value == "true") return true;
-  else if (value == "false") return false;
-  else if (!isNaN(value)) return parseFloat(value.replace(',', '.'));
-  return value;
-}
-
-DatatypeMapper.prototype.aggregateTables = function (data) {
+    DatatypeMapper.prototype.aggregateTables = function (data) {
     // aggregate tables:
     for (var dataKey in data) {
-        var entry = data[dataKey];
-        var tableEntries = {};
-        var toRemove = [];
-        for (var key in entry) {
-            if (key.indexOf('_') != -1) {
-                var splitted = key.split('_');
-                var name = splitted[0];
-                var row = parseInt(splitted[1]);
-                if (!(name in tableEntries)) {
-                    tableEntries[name] = []
-                }
+    var entry = data[dataKey];
+    var tableEntries = {};
+    var toRemove = [];
+    for (var key in entry) {
+    if (key.indexOf('_') != -1) {
+    var splitted = key.split('_');
+    var name = splitted[0];
+    var row = parseInt(splitted[1]);
+    if (!(name in tableEntries)) {
+    tableEntries[name] = []
+    }
 
-                if (splitted.length == 2) { // its a vector of elements
-                    tableEntries[name].push(entry[key])
-                } else if (splitted.length == 3) { // its a matrix of elements
-                    column = parseInt(splitted[2]);
-                    if (tableEntries[name].length < row + 1)
-                        tableEntries[name].push([]);
-                    tableEntries[name][row][column] = entry[key];
-                }
-                toRemove.push(key);
-            }
-        }
+    if (splitted.length == 2) { // its a vector of elements
+    tableEntries[name].push(entry[key])
+    } else if (splitted.length == 3) { // its a matrix of elements
+    column = parseInt(splitted[2]);
+    if (tableEntries[name].length < row + 1)
+    tableEntries[name].push([]);
+    tableEntries[name][row][column] = entry[key];
+    }
+    toRemove.push(key);
+    }
+    }
 
-        for (var i = 0; i < toRemove.length; i++) {
-            delete entry[toRemove[i]];
-        }
+    for (var i = 0; i < toRemove.length; i++) {
+    delete entry[toRemove[i]];
+    }
 
-        for (var key in tableEntries) {
-            entry[key] = tableEntries[key];
-        }
+    for (var key in tableEntries) {
+    entry[key] = tableEntries[key];
     }
-}
+    }
+    }*/
+    return my;
+} (OAAS_VIEW || {}, _, $, Backbone));
